#line 1 "C:/Users/stefan.popovic/Desktop/Brushless/example/Brushless PIC/BrushlessPIC.c"
#line 50 "C:/Users/stefan.popovic/Desktop/Brushless/example/Brushless PIC/BrushlessPIC.c"
 sbit MOTOR_DIR at RE1_bit;

 unsigned int current_speed;
 unsigned int pwm_period;
 char txt[24];


 sbit LCD_RS at LATB4_bit;
 sbit LCD_EN at LATB5_bit;
 sbit LCD_D4 at LATB0_bit;
 sbit LCD_D5 at LATB1_bit;
 sbit LCD_D6 at LATB2_bit;
 sbit LCD_D7 at LATB3_bit;

 sbit LCD_RS_Direction at TRISB4_bit;
 sbit LCD_EN_Direction at TRISB5_bit;
 sbit LCD_D4_Direction at TRISB0_bit;
 sbit LCD_D5_Direction at TRISB1_bit;
 sbit LCD_D6_Direction at TRISB2_bit;
 sbit LCD_D7_Direction at TRISB3_bit;


 char txt1[] = "PWM Duty";
 char txt2[] = "PWM MAX";






 void Display_Init()
 {

 Lcd_Init();
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);
 Lcd_Out(1, 1, txt1);
 Lcd_Out(2, 1, txt2);
 WordToStr(pwm_period, txt);
 Lcd_Out(2, 10, txt);

 }


 void MCU_Init()
 {

 ANSELA = 0;
 ANSELB = 0;
 ANSELC = 0;
 ANSELD = 0;

 PORTD = 255;
 TRISD = 255;

 TRISE2_bit = 0;
 TRISC1_bit = 0;

 ADC_Init();
 Delay_ms(100);
 current_speed = 0;
 pwm_period = 5000;

 PWM2_Init(5000);
 PWM2_Set_Duty(current_speed);
 PWM2_Start();

 }

 void main()
 {

 MCU_Init();
 Display_Init();
 MOTOR_DIR =  0x00 ;

 while(1)
 {

 if (RD0_bit)
 {
 Delay_ms(30);
 current_speed = current_speed +  5 ;

 if (current_speed > pwm_period)
 {
 current_speed = 0;
 }

 PWM2_Set_Duty(current_speed);
 }

 if (RD1_bit) {

 Delay_ms(30);
 current_speed = current_speed -  5 ;

 if (current_speed > pwm_period) {

 current_speed = pwm_period;
 }

 PWM2_Set_Duty(current_speed);
 }



 Delay_ms(20);

 WordToStr(current_speed, txt);
 Lcd_Out(1, 10, txt);

 }
 }
